#include <vector>
#include <string>
#include <iostream>

#ifdef _WIN32
#include "dirent.h"
#else
#include <dirent.h>
#include <string.h>
#endif

using namespace std;

bool hasExtension(string name, string ext)
{
    return (name.find(ext, (name.length() - ext.length())) != std::string::npos);
}

void listfiles (string dirName, std::vector<string> &fileNames) 
{
    DIR *dir;
    struct dirent *ent;
    if ((dir = opendir(dirName.c_str())) != NULL) {
        while ((ent = readdir(dir)) != NULL) {
            if (strcmp(ent->d_name,".") == 0 || strcmp(ent->d_name,"..") == 0) continue;
            string temp_name = ent->d_name;
            switch (ent->d_type) {
            case DT_REG:
            case DT_LNK:
                if (hasExtension(temp_name,".jpg") || hasExtension(temp_name,".png"))
                    fileNames.push_back(temp_name);
                break;
            }
        }
        closedir(dir);
    }
}
 
void listdirs (string dirName, std::vector<string> &folderNames, std::vector<std::vector<string>> &fileNames) 
{
  DIR *dir;
  struct dirent *ent;
  if ((dir = opendir(dirName.c_str())) != NULL) {
    while ((ent = readdir(dir)) != NULL) {
      if (strcmp(ent->d_name,".") == 0 || strcmp(ent->d_name,"..") == 0) continue;
      string temp_name = ent->d_name;
      switch (ent->d_type) {
        case DT_DIR:
          folderNames.push_back(temp_name);
		  fileNames.push_back(std::vector<string>());
          listfiles(dirName + "/" + temp_name,fileNames.back());
          break;
      }
    }
    closedir(dir);
  }
}

void printdirs (std::vector<string> &folderNames, std::vector<std::vector<string>> &fileNames)
{
    for (size_t i=0; i<folderNames.size(); i++) {
        cout << folderNames[i] << ":" << endl;
        for (size_t j=0; j<fileNames[i].size(); j++) {
            cout << "  " << fileNames[i][j] << endl;
        }
    }
}